--Ghost Effect
function Nick.GhostShape(mo, color)
	if mo and mo.valid
		if (leveltime & 1)
			local ghs = P_SpawnGhostMobj(mo)
			if ghs and ghs.valid
				ghs.color = color
				ghs.blendmode = AST_ADD
				ghs.colorized = true
				ghs.frame = FF_FULLBRIGHT|$
			end
		end
	end
end

--thanks katsy for this function
--Bounce checks
function Nick.stupidbouncesectors(mobj, sector)
    for fof in sector.ffloors()
        if not (fof.fofflags & FOF_BOUNCY) and (GetSecSpecial(fof.master.frontsector.special, 1) != 15)
            continue
        end
        if not (fof.fofflags & FOF_EXISTS)
            continue
        end
        if (mobj.z+mobj.height+mobj.momz < fof.bottomheight) or (mobj.z-mobj.momz > fof.topheight)
            continue
        end
        return true
    end
end

--Ground Checks, thanks Luigi Budd
function Nick.IsPlayerOnGround(me)
local posz = me.floorz
local z = me.z + me.momz
local onPosZ
if (P_MobjFlip(me) == -1)
    posz = me.ceilingz
    z = me.z+me.height + me.momz
    onPosZ = (z >= posz)
else
    onPosZ = (z <= posz)
end
    
if (P_IsObjectOnGround(me) or onPosZ) and (not P_CheckDeathPitCollide(me))
	return true
else
	return false
end
end

addHook("ThinkFrame", function(p)
for p in players.iterate
	if not (p.mo and p.mo.valid) continue end
	if p.mo.skin != Nick.skin continue end
	if Nick.IsPlayerOnGround(p.mo)
	and p.mo.state != (S_PLAY_FALL or S_PLAY_SPRING or S_NICKSPRINT)
	or p.powers[pw_carry]
		if p.nick_bouncedid
			p.nick_bouncedid = false
		end
		if p.punch_used
			p.punch_used = false
		end
	end
end
end)

--Flip behavior and checks
function Nick.FlipChecks(mo, z_adjust)
if P_MobjFlip(mo.target.player.mo) == -1
	local pmo = mo.target.player.mo
	if mo and mo.valid
		mo.flags2 = $|MF2_OBJECTFLIP
		mo.eflags = $|MFE_VERTICALFLIP
		mo.z = ($+FixedMul(mo.target.player.mo.scale, z_adjust))
	end
else
	if mo and mo.valid
		mo.flags2 = $ & ~MF2_OBJECTFLIP
		mo.eflags = $ & ~MFE_VERTICALFLIP
	end
end
end

--VFX Spawning
function Nick.SpawnVFX(p, mobjtype, vfxscale)
if not (p.nick_vfx and p.nick_vfx.valid)
	p.nick_vfx = P_SpawnMobj(p.mo.x, p.mo.y, p.mo.z, mobjtype)
	p.nick_vfx.target = p.mo
	p.nick_vfx.scale = vfxscale
else
	if (p == displayplayer) 
	or (p == secondarydisplayplayer) 
		if not camera.chase
			if p.nick_vfx.valid
				p.nick_vfx.flags2 = $|MF2_DONTDRAW
			end
		else
			if p.nick_vfx and p.nick_vfx.valid
				p.nick_vfx.flags2 = $ & ~MF2_DONTDRAW
			end
		end
	end
end
end

--State checks
function Nick.StatesCheck(mo, state_start, state_end)
	if not (mo and mo.valid and mo.player and mo.player.mo.skin == Nick.skin) return end
	if state_end
		return (mo.state >= state_start	and mo.state <= state_end)
	else
		return mo.state == state_start
	end
end