//Nick WolfFang ZE2 compatibility script by Jisk
//Extras by GLide KS

local nick_ze2config_loaded = false

--ZE2 Addon compatibility
local function TryZE2Compat()
	if not ZE2 return end
	if not nick_ze2config_loaded then
        ZE2:AddCharacterConfig("nick", {
            health = 180,
			speed = "normal",
            desc1 = "Brave Nick WolfFang will destroy some zombies...",
            desc2 = "And also survive.",
			desc3 = "Strong and normal speed enough.",
        })
		print("\130Nick WolfFang prepared for Zombie Escape 2")
        nick_ze2config_loaded = true
	end
end

TryZE2Compat()

--Add Character Config if ZE2 is loaded after Nick
addHook("AddonLoaded", function()
    TryZE2Compat()
end)
	
--replace crouch with slide

local function NickSlide(mo)
	return Nick.StatesCheck(mo, S_NICKSLIDE)
end

addHook("PlayerThink", function(player)
	if player.mo and player.mo.skin == "nick"
	and gametype == GT_ZE2
	
		local cmd = player.cmd
		local pmo = player.mo
		local skin = pmo.skin
		
		--play the ZE2 jump sound on Nick players
		if S_IdPlaying(skins[pmo.skin].soundsid[SKSJUMP])
			S_StopSoundByID(pmo, skins[pmo.skin].soundsid[SKSJUMP])
			S_StartSound(pmo, sfx_zjump)
		end

		if not player.soundplayed
			player.soundplayed = false
		end
		
		if not (player.mo.nickslidecheck)
			player.mo.nickslidecheck = false
		end
		if not (player.mo.nickslidetime)
			player.mo.nickslidetime = 0
		end
		if player.mo.nickslidetime > 0
			player.mo.nickslidetime = $1 - 1
		end
		
		if Nick.IsPlayerOnGround(player.mo) and player["ze2_info"].crouching then
			if player.speed == 0
				player.mo.state = S_PLAY_STND
			else
				Nick.PlayerThinkSystemSlideNick(player)
				player.panim = PA_DASH
				P_SpawnSkidDust(player, 18*player.mo.scale, leveltime%5 == 0 and sfx_s3k7e or nil)
			end
			player.mo.nickslidecheck = true
		else
			if pmo.state == S_NICKSLIDE or pmo.state == S_PLAY_STND then
				if (player.speed/FU) then
					pmo.frame = A
					pmo.state = S_PLAY_WALK
				else
					pmo.frame = A
					pmo.state = S_PLAY_STND
				end
			end
		end
	end
end)