--Thanks for the guidance about this lib luigi budd
--MenuLib Updated from GitHub 3/May/2025

local ML = MenuLib
local buffer = ""
local bufferid = ML.newBufferID()

local com_buffer = ""
local com_bufferid = ML.newBufferID()

local cv_nick_looking = CV_FindVar("nick_looking")

local nick_lookingfile = io.openlocal("client/Nick/Looking.dat", "r")

ML.addMenu({
	stringId = "nick-main",
	title = "Nick WolfFang Menu",
	width = 270,
	height = 170,
	
	drawer = function(v, ML, menu, props)
		local corner_x = props.corner_x + 10
		local corner_y = props.corner_y + 18
		local buttons_spacing = 4
		local buttons_height = 20
		local buttons_width = 85
		
		local offsetposx = 10
		local offsetposy = -10
		
		--let's draw also the player
		local posx = offsetposx+200
		local posy = offsetposy+150
		
		--a copy of translation handlers if the player is on spectator or not in game
		local ptranslation
		local pcolor
		if not consoleplayer.nick_legacy
			if consoleplayer.nick_clonefighter
				if not G_GametypeHasTeams()
					if not ptranslation
						ptranslation = "Grayscale"
					end
				end
			else
				if ptranslation
					ptranslation = nil
				end
			end
		else
			if not consoleplayer.nick_legacy_ison
				ptranslation = "Nick_Legacy"
				pcolor = SKINCOLOR_BROWN
			else
				ptranslation = nil
				pcolor = nil
			end
		end
			
		if consoleplayer.mo and consoleplayer.mo.valid
			local playersprite2 = v.getSprite2Patch(consoleplayer.skin, consoleplayer.mo.sprite2, false, consoleplayer.mo.frame, 2)
			local playersprite = v.getSpritePatch(consoleplayer.mo.sprite, consoleplayer.mo.frame, 2)
			v.draw(posx, posy, (playersprite2 or playersprite), nil, v.getColormap(consoleplayer.skin, consoleplayer.mo.color, consoleplayer.mo.translation))
		else
			local default = v.getSprite2Patch(consoleplayer.skin, SPR2_STND, false, 0, 2)
			v.draw(posx, posy, default, nil, v.getColormap(consoleplayer.skin, pcolor or consoleplayer.skincolor, ptranslation or nil))
		end
		
		--Powers color
		local powersx = offsetposx+155
		local powersy = offsetposy+90
		local defaultpowerscolorlist = {
			SKINCOLOR_CERULEAN,
			SKINCOLOR_ORANGE,
			SKINCOLOR_RED,
			SKINCOLOR_PURPLE,
		}
		
		local powerframe = (leveltime/(2*(3/2))) % (3)
		local powercolor = defaultpowerscolorlist[(leveltime/(30)) % (5) or 1]
		local powersprite = v.getSpritePatch(SPR_NCKB, powerframe, 2)
		v.drawString(powersx, powersy-40, "Powers color", V_ALLOWLOWERCASE|V_YELLOWMAP, "thin-center")
		v.drawScaled(powersx*FU, powersy*FU, FU/2, powersprite, V_ADD, v.getColormap(nil, consoleplayer.nick_powerscolor or powercolor))
		
		--Nick Looking
		local lookinx = offsetposx + 250
		local lookiny = offsetposy + 72
		local lookingsprite_off = v.cachePatch("NICK_LOOKIN_OFF")
		local lookinanim = (leveltime/(15*(3/2))) % (2)
		local lookingsprite = v.cachePatch("NICK_LOOKIN"..tostring(lookinanim))
		if consoleplayer.nick_looking
			v.drawString(lookinx, lookiny-22, "Looking Head", V_ALLOWLOWERCASE|V_GREENMAP, "thin-center")
			v.drawScaled(lookinx*FU, lookiny*FU, FU/2, lookingsprite, nil,v.getColormap(consoleplayer.skin, pcolor or consoleplayer.skincolor, ptranslation))
		--else
			--v.drawScaled(lookinx*FU, lookiny*FU, FU/2, lookingsprite_off, nil, v.getColormap(consoleplayer.skin, pcolor or consoleplayer.skincolor, ptranslation))
		end

		--Lets add some buttons with their descriptions
		
		ML.addButton(v, {
			id = 1,
			x = corner_x+5,
			y = corner_y+10,
			width = buttons_width,
			height = buttons_height,
			
			name = "Looking head",
			color = 5,
			
			selected = {
				color = 83
			},
			
			pressFunc = function()
				if not consoleplayer.nick_looking
					ML.client.commandbuffer = "nick_looking 1"
				else
					ML.client.commandbuffer = "nick_looking 0"
				end
			end
		})
		
		ML.addButton(v, {
			id = 2,
			x = corner_x+5,
			y = corner_y+buttons_spacing+(buttons_height)+10,
			width = buttons_width,
			height = buttons_height,
			
			name = "Clone Fighter",
			color = 5,
			
			selected = {
				color = 83
			},
			
			pressFunc = function()
				if not consoleplayer.nick_clonefighter
					ML.client.commandbuffer = "nick_clonefighter 1"
				else
					ML.client.commandbuffer = "nick_clonefighter 0"
				end
			end
		})
		
		ML.addButton(v, {
			id = 3,
			x = corner_x+5,
			y = corner_y+((buttons_height+buttons_spacing)*2)+10,
			width = buttons_width,
			height = buttons_height,
			
			name = "Legacy Colors",
			color = 5,
			
			selected = {
				color = 83
			},
			
			pressFunc = function()
				if not consoleplayer.nick_legacy
					ML.client.commandbuffer = "nick_legacy 1"
				else
					ML.client.commandbuffer = "nick_legacy 0"
				end
			end
		})
		
		ML.addButton(v, {
			id = 4,
			x = corner_x+5,
			y = corner_y+((buttons_height+buttons_spacing)*3)+10,
			width = buttons_width,
			height = buttons_height,
			
			name = "Set powers color",
			color = 5,
			
			selected = {
				color = 83
			},
			
			pressFunc = function()
				ML.startTextInput(com_buffer, com_bufferid,nil,function()
					ML.client.commandbuffer = "nick_powerscolor "..ML.client.textbuffer
					com_buffer = ""
				end, "Type a color name to use for Nick's powers. type 0 for default")
			end
		})
		
		ML.addButton(v, {
			id = 5,
			x = corner_x+5,
			y = corner_y+((buttons_height+buttons_spacing)*5),
			width = buttons_width,
			height = buttons_height,
			
			name = "Reset to defaults",
			color = 38,
			
			selected = {
				color = 35
			},
			
			pressFunc = function()
				ML.initPopup(ML.findMenu("reset-confirmation"))
			end
		})
		
		-- \n
		local description_text
		
		if ML.client.hovering == 1
			description_text = "\130Description: \128Toggle Nick's looking\nhead when standing still."
		elseif ML.client.hovering == 2
			description_text = "\130Description: \128Toggle clonefighter\ncolors like Fang and Metal Sonic\nbosses do. This option doesn't save."
		elseif ML.client.hovering == 3
			description_text = "\130Description: \128Toggle legacy colors,\nreference to Nick's old design from\n2016-2017. Preserving history!"
		elseif ML.client.hovering == 4
			description_text = "\130Description: \128Set Nick's powers color\nlike Wolf Buster, Slide afterimages\nand other effects."
		elseif ML.client.hovering == 5
			description_text = "\130Description: \128\133Resets all your\ncustomization settings."
		else
			description_text = ""
		end
		
		v.drawString(129,150, description_text, V_ALLOWLOWERCASE,"thin")
	end
})

ML.addMenu({
	stringId = "reset-confirmation",
	title = "WARNING!",
	width = 147,
	height = 60,
	color = 41,
	outline = 35,
	x = 85,
	y = 90,
	ps_flags = PS_NOESCAPE,

	drawer = function(v, ML, menu, props)
		v.drawString((props.corner_x + 4)+menu.width/2, (props.corner_y + 10), "Are you sure?", V_ALLOWLOWERCASE, "center")
		ML.addButton(v, {
			id = 6,
			x = props.corner_x+5,
			y = props.corner_y+35,
			width = 66,
			height = 20,
			
			name = "Yes",
			color = 16,
			
			selected = {
				color = 103
			},
			
			pressFunc = function()
				ML.client.commandbuffer = "nick_legacy 0;nick_powerscolor off;nick_clonefighter 0;nick_looking 0"
				MenuLib.initPopup(-1)
			end
		})
		ML.addButton(v, {
			id = 7,
			x = props.corner_x+77,
			y = props.corner_y+35,
			width = 66,
			height = 20,
			
			name = "No",
			color = 16,
			
			selected = {
				color = 35
			},
			
			pressFunc = function()
				MenuLib.initPopup(-1)
			end
		})
	end
})

COM_AddCommand("nick_menu", function(p)
	if isdedicatedserver then return end
	
	if p.mo and p.mo.valid and p.mo.skin != "nick" return end
	if (#ML.client.popups)
		ML.initPopup(-1)
	else
		ML.initMenu(ML.findMenu("nick-main"))
	end
end, COM_LOCAL)