/*
"Custom VFX for Nick" - GLide KS
*/
//Rewritten by Mr.FondusBroMan

-----------------Wolf Buster----------------
freeslot("MT_NICKBOOST", "S_NICKBOOST01", "S_NICKBOOST02", "S_NICKBOOST03", "SPR_NCKB")

states[S_NICKBOOST01] = {SPR_NCKB, FF_FULLBRIGHT|FF_ADD|A, 2, nil, 0, 0, S_NICKBOOST02}
states[S_NICKBOOST02] = {SPR_NCKB, FF_FULLBRIGHT|FF_ADD|B, 2, nil, 0, 0, S_NICKBOOST03}
states[S_NICKBOOST03] = {SPR_NCKB, FF_FULLBRIGHT|FF_ADD|C, 2, nil, 0, 0, S_NICKBOOST01}

mobjinfo[MT_NICKBOOST] = {
        doomednum = -1,
        spawnstate = S_NICKBOOST01,
		spawnhealth = 100,
        speed = 0,
        radius = 90*FRACUNIT,
        height = 90*FRACUNIT,
        mass = 1,
		flags = MF_NOGRAVITY|MF_NOCLIP|MF_FLOAT|MF_NOCLIPHEIGHT
}

local nk = Nick

local boostoffset = 30*FU

local function NickPunch(mo)
	if not (mo and mo.valid) return end
	
	return mo.state == S_NICKPUNCH
end

local cv_nick_chasecam = CV_FindVar("chasecam")
local cv_nick_chasecam2 = CV_FindVar("chasecam2")

local boostfxspawned

addHook("PlayerThink", function(p)
    if p.mo and p.mo.valid
        if p.mo.skin == Nick.skin
			if (MM and MM.isMM()) return end
			local speed = FixedHypot(p.mo.player.rmomx, p.mo.player.rmomy)
            if NickPunch(p.mo)
				p.drawangle = p.mo.angle
				Nick.SpawnVFX(p, MT_NICKBOOST, p.mo.scale*3/2)
				if ((player == displayplayer) and not camera.chase)
				and nick_boostfx and nick_boostfx.valid
					nick_boostfx.flags2 = $|MF2_DONTDRAW
				end
                p.tracer = nick_boostfx
				
				if not (p.powers[pw_shield] & SH_NOSTACK == SH_WHIRLWIND)
					p.mo.momz = P_MobjFlip(p.mo)<0 and min($,p.mo.scale*16) or max($,-p.mo.scale*16)
				else
					p.mo.momz = P_MobjFlip(p.mo)<0 and min($,p.mo.scale*10) or max($,-p.mo.scale*10)
				end
            end
            if speed >= 50*p.mo.scale
			and P_IsObjectOnGround(p.mo)
			and (p.cmd.forwardmove or p.cmd.sidemove)
				P_SpawnSkidDust(p, 34*p.mo.scale, sfx_none)
				P_SpawnSkidDust(p, 18*p.mo.scale, sfx_none)
            end
			local mo = p.mo
			if mo.state == S_PLAY_RUN and speed >= FixedMul(50*FU, mo.scale)
				if mo.state != S_PLAY_DASH
					mo.state = S_PLAY_DASH
				end
			elseif mo.state == S_PLAY_DASH and speed < FixedMul(50*FU, mo.scale)
				if mo.state != S_PLAY_RUN
					mo.state = S_PLAY_RUN
				end
			end
		end
    end
end)

addHook("MobjMoveBlocked", function(mo)
	if (mo and mo.valid and mo.player.mo and mo.player.mo.valid and mo.player and mo.skin == Nick.skin)
	and mo.player.playerstate == PST_LIVE
	and not mo.player.exiting
	and not P_PlayerInPain(mo.player)
	and NickPunch(mo)
		if not P_IsObjectOnGround(mo)
			if (MM and MM.isMM()) return end
			mo.player.lastlinehit = -1
			mo.player.lastsidehit = -1
			P_SlideMove(mo)
			mo.player.powers[pw_pushing] = 3
			local line = lines[mo.player.lastlinehit]
			if line and line.valid
				if (line.frontsector)
					if (line.frontsector.ceilingheight == line.frontsector.floorheight) and (mo.z > line.frontsector.ceilingheight)
						return
					end
				end
				if (line.backsector)
					if (line.backsector.ceilingheight == line.backsector.floorheight) and (mo.z > line.backsector.ceilingheight)
						return
					end
				end
				if not P_IsObjectOnGround(mo)
				and not P_PlayerInPain(mo.player)
				and not (line and line.backsector
				and line.backsector.ceilingpic == "F_SKY1"
				and line.frontsector
				and line.frontsector.ceilingpic == "F_SKY1"
				and (mo.z >= line.frontsector.ceilingheight
				or mo.z >= line.backsector.ceilingheight))
					local p = mo.player
					local target = mo
				
					if (consoleplayer == p)
					and FixedHypot(mo.player.rmomx, mo.player.rmomy) < mo.player.normalspeed
						P_StartQuake(14*mo.scale, TICRATE/5, {mo.x, mo.y, mo.z})
					end
					for i = 0, 8
						local thok_dust = P_SpawnMobjFromMobj(mo, 0, 0, 0, MT_THOK)
						P_Thrust(thok_dust, p.drawangle + ANGLE_90, sin(i*ANGLE_45)*10)
						P_SetObjectMomZ(thok_dust, cos(i*ANGLE_45)*10)
						if mo.nickboostmobj and mo.nickboostmobj.valid
							thok_dust.color = mo.nickboostmobj.color
						end
						thok_dust.colorized = true
						thok_dust.blendmode = AST_ADD
						thok_dust.state = S_SPINFIRE1
						thok_dust.scale = mo.scale
						thok_dust.tics = 10
						thok_dust.destscale = mo.scale/8
						thok_dust.fuse = TICRATE/2
						thok_dust.flags = $|MF_SCENERY
					end
					if (mo.eflags & MFE_UNDERWATER)
						P_InstaThrust(mo, mo.player.drawangle+ANGLE_180, 5*FRACUNIT/2)
					else
						P_InstaThrust(mo, mo.player.drawangle+ANGLE_180, 5*FRACUNIT)
					end
					mo.player.pflags = $ &~ PF_JUMPED
					P_DoJump(mo.player,false)
					if FixedHypot(mo.player.rmomx, mo.player.rmomy) >= mo.player.normalspeed and FixedHypot(mo.player.rmomx, mo.player.rmomy) < Nick.WB_high_speed*mo.scale
						P_SetObjectMomZ(mo, max(0, mo.player.speed/11), true) --extra height on high speeds
						if (consoleplayer == p)
							P_StartQuake(25*mo.scale, TICRATE/5, {mo.x, mo.y, mo.z})
						end
					elseif FixedHypot(mo.player.rmomx, mo.player.rmomy) >= Nick.WB_high_speed*mo.scale
						P_SetObjectMomZ(mo, max(0, mo.player.speed/6), true) --extra height on high speeds
						if (consoleplayer == p)
							P_StartQuake(40*mo.scale, TICRATE/5, {mo.x, mo.y, mo.z})
						end
					end
					mo.player.pflags = $ &~ PF_STARTJUMP
					S_StartSound(mo, sfx_s3k5f)
					mo.state = S_PLAY_SPRING
					p.kickdid = false
					if not mo.player.nick_bouncedid
						mo.player.nick_bouncedid = true
					end
				end
			elseif mo.player.nick_bouncedid
				mo.player.nick_bouncedid = false
			end
		end
		return true
	end
end, MT_PLAYER)

addHook("MobjThinker", function(mo)
	if (MM and MM.isMM()) return end
	
	local target = mo.target
    if not (mo and mo.valid) then
        return
    end

    if not (mo.target
    and mo.target.valid
    and mo.target.player)
	or target.player.mo.state != S_NICKPUNCH then
        P_RemoveMobj(mo)
        return
    end
	
	local low_speed = Nick.WB_low_speed*target.scale
	local medium_speed = Nick.WB_medium_speed*target.scale
	local high_speed = Nick.WB_high_speed*target.scale

    local x, y = cos(mo.target.player.drawangle),sin(mo.target.player.drawangle)

    P_MoveOrigin(mo, mo.target.x+5+x, mo.target.y+5+y, mo.target.z)
	mo.angle = mo.target.player.drawangle
	
	local boostghost = P_SpawnGhostMobj(mo)
	P_MoveOrigin(boostghost,mo.x,mo.y,mo.z)
	boostghost.fuse = 4
	boostghost.dispoffset = 50
	
	local p = target.player
	
	local boostcolor = 0
	if not G_GametypeHasTeams()
		if not (mo.target.player.powers[pw_shield] & SH_NOSTACK == SH_WHIRLWIND)
			if not p.nick_powerscolor
				if FixedHypot(p.rmomx, p.rmomy) <= low_speed --Low speed color
					boostcolor = SKINCOLOR_CERULEAN
				elseif FixedHypot(p.rmomx, p.rmomy) >= low_speed and FixedHypot(p.rmomx, p.rmomy) < medium_speed --Medium Speed Color
					boostcolor = SKINCOLOR_ORANGE
				elseif FixedHypot(p.rmomx, p.rmomy) >= medium_speed and FixedHypot(p.rmomx, p.rmomy) < high_speed --High Speed Color
					boostcolor = SKINCOLOR_RED
					mo.tics = 1
				elseif FixedHypot(p.rmomx, p.rmomy) >= high_speed --Ultra Speed Color
					boostcolor = SKINCOLOR_PURPLE
					mo.tics = 1
				end
			else
				boostcolor = p.nick_powerscolor
				if FixedHypot(p.rmomx, p.rmomy) >= medium_speed and FixedHypot(p.rmomx, p.rmomy) < high_speed --High Speed Color
					mo.tics = 1
				elseif FixedHypot(p.rmomx, p.rmomy) >= high_speed --Ultra Speed Color
					mo.tics = 1
				end
			end
		else
			boostcolor = SKINCOLOR_CARBON
		end
	else
		boostcolor = p.mo.color
		if FixedHypot(p.rmomx, p.rmomy) >= medium_speed and FixedHypot(p.rmomx, p.rmomy) < high_speed --High Speed Color
			mo.tics = 1
		elseif FixedHypot(p.rmomx, p.rmomy) >= high_speed --Ultra Speed Color
			mo.tics = 1
		end
	end
		
	if FixedHypot(p.rmomx, p.rmomy) >= high_speed
		nk.GhostShape(target, boostcolor)
	end
	mo.color = boostcolor
	mo.dispoffset = 0
	boostghost.dispoffset = 50
	nk.FlipChecks(mo, -8*FU)
end, MT_NICKBOOST)

-----------------Sprint VFX----------------

freeslot("S_WOOSH_NICK", "SPR_WOSH","MT_WOOSH_FOLLOW")

states[S_WOOSH_NICK] = {SPR_WOSH, FF_ANIMATE|A, -1, nil, 4, 2, S_WOOSH_NICK}

mobjinfo[MT_WOOSH_FOLLOW] = {
    radius = 1,
    height = 1,
    spawnstate = S_WOOSH_NICK,
	flags = MF_NOCLIP|MF_NOBLOCKMAP|MF_NOCLIPHEIGHT|MF_NOGRAVITY
}

addHook("MobjSpawn", function(mo)
    mo.offset = 7
end, MT_WOOSH_FOLLOW)

addHook("MobjThinker", function(mo)
	if (MM and MM.isMM()) return end
	
    if not (mo and mo.valid) then
        return
    end

    if not (mo.target
    and mo.target.valid
    and mo.target.player) then
        P_RemoveMobj(mo)
        return
    end

    local x, y = cos(mo.target.player.drawangle),sin(mo.target.player.drawangle)

    P_MoveOrigin(mo, mo.target.x+(mo.offset*x), mo.target.y+(mo.offset*y), mo.target.z)
	mo.angle = mo.target.player.drawangle
	nk.FlipChecks(mo, 76*FU)
end, MT_WOOSH_FOLLOW)

-----------------Strong Slide VFX----------------

freeslot("S_WOOSHSLD_NICK", "SPR_SWSH","MT_WOOSHSLD_FOLLOW")

states[S_WOOSHSLD_NICK] = {SPR_SWSH, FF_ANIMATE|A, -1, nil, 4, 1, S_WOOSHSLD_NICK}

mobjinfo[MT_WOOSHSLD_FOLLOW] = {
    radius = 1,
    height = 1,
    spawnstate = S_WOOSHSLD_NICK,
	flags = MF_NOCLIP|MF_NOBLOCKMAP|MF_NOCLIPHEIGHT|MF_NOGRAVITY
}

addHook("MobjSpawn", function(mo)
    mo.offset = 7
end, MT_WOOSHSLD_FOLLOW)

addHook("MobjSpawn", function(mo)
    mo.offset = 0
end, MT_NICKBOOST)

addHook("MobjThinker", function(mo)
	if (MM and MM.isMM()) return end

    if not (mo and mo.valid) then
        return
    end

    if not (mo.target
    and mo.target.valid
    and mo.target.player) then
        P_RemoveMobj(mo)
        return
    end
	
	if not (mo.target
    and mo.target.valid
    and mo.target.player)
	or mo.target.player.speed <= 40*mo.target.player.mo.scale then
        P_RemoveMobj(mo)
        return
    end

    local x, y = cos(mo.target.player.drawangle),sin(mo.target.player.drawangle)

    P_MoveOrigin(mo, mo.target.x+(mo.offset*x), mo.target.y+(mo.offset*y), mo.target.z)
	mo.angle = mo.target.player.drawangle
	nk.FlipChecks(mo, 34*FU)
end, MT_WOOSHSLD_FOLLOW)