--Speed Effects (Open Assets) by Aurum Mighty

local function Wind(mobj)
    local r = mobj.radius / FRACUNIT
    local explosion = P_SpawnMobj(
        mobj.x + (P_RandomRange(r, -r) * FRACUNIT),
        mobj.y + (P_RandomRange(r, -r) * FRACUNIT),
        mobj.z + (P_RandomKey(mobj.height / FRACUNIT) * FRACUNIT) - mobj.height/2,
        MT_THOK)
    explosion.sprite = SPR_RAIN
    explosion.renderflags = $|RF_PAPERSPRITE
    explosion.angle = R_PointToAngle2(0, 0, mobj.momx, mobj.momy)
    explosion.rollangle = R_PointToAngle2(0, 0, R_PointToDist2(0, 0, mobj.momx, mobj.momy), mobj.momz) + ANGLE_90
    explosion.source = mobj
    explosion.blendmode = AST_ADD
end

addHook('ThinkFrame', do
	for player in players.iterate do
	if player.mo and player.mo.skin != "nick" continue end
		if player.mo and player.mo.scale and player.mo.friction and player.mo.movefactor then
			local skin = skins[player.mo.skin]
			local grounded = P_IsObjectOnGround(player.mo)
			if player.mo.state ~= S_PLAY_DEAD and player.mo.state ~= S_PLAY_DRWN then
				if player.speed >= 50*FRACUNIT
				or (player.speed >= 20*FRACUNIT and player.mo.state == S_NICKPUNCH)
		        	Wind(player.mo)
		        end
			end
		end
	end
end)