//Rewritten by Mr.FondusBroMan
//General and actual maintainer: GLide KS
local nk = Nick

--Setting these states as damage
local function NickDamage(mo)
	return 
	nk.StatesCheck(mo, S_NICKKICK01, S_NICKKICK10) or
	nk.StatesCheck(mo, S_NICKSPRINT)
end
local function NickDamage2(mo)
	return nk.StatesCheck(mo, S_NICKKICK01, S_NICKKICK10)
end
local function NickPoses(mo)
	return 
	nk.StatesCheck(mo, S_NICK_STANCE01, S_NICK_STANCE09) or
	nk.StatesCheck(mo, S_NICK_WAIT01, S_NICK_WAIT10) or
	nk.StatesCheck(mo, S_NICKBRUH) or
	nk.StatesCheck(mo, S_NICKSIT2)
end
local function NickPunchDamage(mo)
	return nk.StatesCheck(mo, S_NICKPUNCH)
end
local function NickDash(mo)
	return nk.StatesCheck(mo, S_NICKSPRINT)
end
local function NickSlide(mo)
	return nk.StatesCheck(mo, S_NICKSLIDE)
end
local function NickSlideJump(mo)
	return nk.StatesCheck(mo, S_NICKSLIDEJUMP1, S_NICKSLIDEJUMP6)
end

--Slide System
function nk.PlayerThinkSystemSlideNick(p) 
	if not (p and p.valid and p.mo and p.mo.valid) return end
	if NickSlide(p.mo) return end
	if not p.mo.nickdash
		p.mo.nickslidetime = 3
		p.mo.state = S_NICKSLIDE
	end
end

addHook("PlayerCanDamage", function(p)
if (p.mo.skin == Nick.skin)
	if NickDamage(p.mo) or NickPunchDamage(p.mo) or NickSlide(p.mo) or NickSlideJump(p.mo)
		return true
	end
end
end)

-- Which strong effects will have Nick when obtained?
local STR_NICK = STR_SPRING|STR_SPIKE|STR_BUST|STR_ANIM
--Second one for Spin kick. only removing spring powerup and spikes
local STR_NICK2 = STR_BUST|STR_ANIM 

---Swipe kick homing handler---
local function HomingDamage(damagemobj, mo)
if NickDamage2(mo) and damagemobj.valid
	mo.nick_homingcheck = true
end
end

local function ObjectTouched(mobjtouch, mo)
if NickDamage2(mo) and mobjtouch.valid
	mo.nick_touchcheck = true
end
end

addHook("MobjDamage", function(damagemobj, mo)
	if damagemobj.valid
		return HomingDamage(damagemobj, mo)
	end
end)

addHook("MobjDeath", function(damagemobj, mo)
	if damagemobj.valid and damagemobj.flags & MF_MONITOR
		return HomingDamage(damagemobj, mo)
	end
end)

addHook("MobjCollide", function(mobjtouch, mo)
	if mobjtouch.valid
		return ObjectTouched(mobjtouch, mo)
	end
end, MT_PLAYER)

/*-----------------------DOUBLE JUMP/SWIPEKICK--------------------------*/
local function CustomDoubleJump(p)
if p and p.mo and p.mo.skin == Nick.skin
--Exclude abilities from Saxa's Murder Mystery
and gametype != (GT_SAXAMM or GT_ZE2)
	if p.charability == CA_NICKABILITY
	and (p.playerstate == PST_LIVE)
		if not (nk.IsPlayerOnGround(p.mo))
			if (p.pflags & PF_JUMPED)
				if not (p.nick_bouncedid or p.mo.state == S_NICKPUNCH)
					if not NICK_RESTRICT_HOMING
					if p.enemytarget and p.enemytarget.valid
					and p.enemydistance <= NICK_HOMINGDISTANCE
						if not p.kickdid
						and not NickSlide(mo)
							S_StartSound(p.mo, sfx_spnkck)
							p.mo.state = S_NICKKICK01
							p.pflags = $&~(PF_THOKKED)
				
							if p.enemytarget
								p.mo.tracer = p.enemytarget
								p.mo.target = p.mo.tracer
							end
							p.kickdid = true
						end
						end
					end
				else
					if not p.jumpdid
					and not NICK_RESTRICT_DOUBLEJUMP
					and not (p.gotflag or p.gotcrystal)
						--The 2nd Jump
						p.pflags = $ & ~(PF_JUMPED|PF_SPINNING)
						p.pflags = $ & ~PF_NOJUMPDAMAGE
						p.mo.state = S_PLAY_NICKDOUBLEJUMP
						S_StartSound(p.mo, sfx_nckdjp)
					
						for i = 1, 12
							local dust = P_SpawnMobjFromMobj(p.mo, 0, 0, 0, MT_SPINDUST)
							dust.angle = ANG30*i
							dust.flags = $|MF_SCENERY
							dust.frame = $|FF_TRANS50
							P_InstaThrust(dust, dust.angle, 16*dust.scale)
							P_Thrust(dust, p.mo.angle, p.speed/2)
						end
						P_DoJump(p, false)
						p.pflags = $|PF_JUMPED|PF_THOKKED
						p.kickdid = false
						p.nick_bouncedid = false
						p.jumpdid = true
					end
				end
			end
		end
	end
end
end

local function KickChecks(p)
	if p.kickdid 
		if Nick.IsPlayerOnGround(p.mo)
		or p.chaintimer
		and p.mo.state == S_NICKKICK_OFFHOMING
			p.kickdid = false
		end
	end
	if p.chaintimer
		p.chaintimer = $-1
	end
	if p.enemytarget and p.enemytarget.valid
	and p.kickdid
	and NickDamage(p.mo)
	and not p.mo.nick_touchcheck
		P_HomingAttack(p.mo, p.enemytarget)
	end
	-- stop homing to springs ffs
	if NickDamage(p.mo)
	and not p.mo.nick_homingcheck
		if (p.mo.eflags & MFE_SPRUNG)
			if p.mo.momz > 0
				p.mo.state = S_PLAY_SPRING
			else
				p.mo.state = S_PLAY_FALL
			end
		end
	end
	if (p.mo.eflags & MFE_SPRUNG)
	and (p.pflags & PF_JUMPED)
		p.kickdid = false
		p.jumpdid = false
		p.punch_used = false
		p.nick_bouncedid = false
	end
end

/*------------------------------Main Script---------------------------*/
addHook("PlayerThink", function(p)
	if not (p and p.valid and p.mo and p.mo.valid) return end
	local mo = p.mo
	local cmd = p.cmd
	if mo.skin == Nick.skin
		local speed = FixedHypot(p.mo.player.rmomx, p.mo.player.rmomy)
		KickChecks(p)
		if not p.spindown
			p.spindown = false
		end
		if (cmd.buttons & BT_SPIN)
			p.spindown = true
		else
			p.spindown = false
		end
		if p.canceltimer
		and not (cmd.buttons & BT_SPIN)
			p.canceltimer = $-1
		end
		if not p.chaintimer
		and not Nick.IsPlayerOnGround(mo)
		and (p.pflags & PF_JUMPED)
			if p.mo.state == S_NICKKICK_OFFHOMING
				if mo.momz > 0
					mo.state = S_PLAY_SPRING
				else
					mo.state = S_PLAY_FALL
				end
				p.kickdid = true
			end
		end
		
		--target
			
		--Jump checks
		if p.jumpdid and not (p.pflags & PF_JUMPED)
			p.jumpdid = false
		end
		if not mo.nick_touchcheck
			mo.nick_touchcheck = false
		end
		--Slide checks
		local rollingcheck = mo.state == S_PLAY_ROLL and p.pflags & PF_SPINNING
		if not (mo.spindown)
			mo.spindown = 0
		end
		if not (mo.nickslidecheck)
		or rollingcheck
			mo.nickslidecheck = false
		end
		
		--Legacy?!
		if p.nick_legacy
			if not p.nick_legacy_ison
				mo.translation = "Nick_Legacy"
				if not ((MM and MM:isMM()) or G_GametypeHasTeams())
				and not p.color_changed
					p.skincolor = SKINCOLOR_BROWN
					mo.color = SKINCOLOR_BROWN
					p.color_changed = true
				end
				p.nick_legacy_ison = p.nick_legacy
			end
			if not mo.translation and p.nick_legacy_ison
				mo.translation = "Nick_Legacy"
			end
		else
			p.color_changed = false
			if p.nick_legacy_ison
				mo.translation = nil
				if not ((MM and MM:isMM()) or G_GametypeHasTeams())
				and not p.color_changed
					p.skincolor = SKINCOLOR_BETTER_RUST
					mo.color = SKINCOLOR_BETTER_RUST
					p.color_changed = true
				end
				p.nick_legacy_ison = p.nick_legacy
			end
		end
		
		--Clone Fighter!
		if not p.nick_legacy
			if p.nick_clonefighter
				if not G_GametypeHasTeams()
					if not mo.translation
						mo.translation = "Grayscale"
					end
				end
			else
				if mo.translation
					mo.translation = nil
				end
			end
		end
		
		--Homing lock on graphic
		if not (p.powers[pw_shield] & SH_NOSTACK == SH_ATTRACT)
		and not (p.nick_bouncedid or p.mo.state == S_NICKPUNCH)
		and gametype != (GT_SAXAMM or GT_ZE2)
		and not p.powers[pw_carry]
		and not Nick.IsPlayerOnGround(mo)
		and not p.kickdid
			p.enemytarget = P_LookForEnemies(p, true, false)
			if p.enemytarget and p.enemytarget.valid
				p.enemydistance = R_PointToDist2(p.mo.x, p.mo.y, p.enemytarget.x, p.enemytarget.y)
			end
			
			local t = p.enemytarget
				
			if t and t.valid
				local tdist = p.enemydistance
				if tdist and tdist <= NICK_HOMINGDISTANCE
					P_SpawnLockOn(p, t, S_LOCKON1)
				end
			end
		end
		
		
		--Slide spin button checks
		if (cmd.buttons & BT_SPIN) 
		and gametype != (GT_SAXAMM or GT_ZE2)
		and not p.exiting
		and p.speed > 0
		and not p.powers[pw_carry]
		and not NICK_RESTRICT_SLIDE
		and not (p.pflags & PF_STASIS)
		and not (mo.tracer and mo.tracer.type == MT_TUBEWAYPOINT)
		and not mo.nickslidecheck
		and (
			mo.spindown == 0
			or
			--Allow sliding out of spinning
			rollingcheck
		)
		and not srb2p
		and (P_IsObjectOnGround(mo) and not P_CheckDeathPitCollide(mo))
			Nick.PlayerThinkSystemSlideNick(p)
			mo.spindown = 1
		end
		if not (cmd.buttons & BT_SPIN)
			mo.spindown = 0
		end
		if not (mo.nickslidetime)
			mo.nickslidetime = 0
		end
		if mo.nickslidetime > 0
			mo.nickslidetime = $ - 1
		end
		-- Slide Cosmetics and power ups
		if not (mo.slidechecktimer)
			mo.slidechecktimer = 0
		end
		if mo.slidechecktimer > 0
			mo.slidechecktimer = $1 - 1 
		end
		if NickSlide(mo)
			mo.slidechecktimer = 3
			if speed >= Nick.Slide_strongspeed*mo.scale
				p.powers[pw_strong] = $|STR_NICK
				if not G_GametypeHasTeams()
					if not p.nick_powerscolor
						nk.GhostShape(mo, SKINCOLOR_PURPLE)
					else
						nk.GhostShape(mo, p.nick_powerscolor)
					end
				else
					nk.GhostShape(mo, mo.color)
				end
				if Nick.IsPlayerOnGround(mo)
					P_SpawnSkidDust(p, 34*mo.scale, leveltime%3 == 0 and sfx_s3k7e or nil)
				end
				Nick.SpawnVFX(p, MT_WOOSHSLD_FOLLOW, mo.scale*3/2)
			else
				p.powers[pw_strong] = $ &~STR_NICK
			end
			p.panim = PA_ROLL
			if not (p.pmomz or (p.mo.eflags & MFE_APPLYPMOMZ))
				p.panim = PA_DASH
			end
			if Nick.IsPlayerOnGround(mo)
				P_SpawnSkidDust(p, 18*mo.scale, leveltime%5 == 0 and sfx_s3k7e or nil)
			end
			mo.nickslidecheck = true
			p.pflags = $|PF_SPINNING|PF_SPINDOWN --Slide has rolling effects
			mo.nickspincheck = true
			mo.spindown = 1
			if p.speed == 0
				if (mo.eflags & MFE_JUSTHITFLOOR)
					mo.state = S_PLAY_WALK
				else
					mo.state = S_PLAY_SPRING
				end
			elseif not (cmd.buttons & BT_SPIN)
			and mo.nickslidecheck == true
				if Nick.IsPlayerOnGround(mo)
					mo.state = S_PLAY_WALK
					mo.nickslidecheck = false
				end
			end
			
			if nk.stupidbouncesectors(mo,mo.subsector.sector)
			and (mo.momz ~= 0)
				mo.state = S_PLAY_ROLL
				p.pflags = $|PF_JUMPED &~(PF_THOKKED|PF_SPINNING)
			end
		else
			if mo.nickslidecheck == true
				mo.nickslidecheck = false
			end
			if mo.nickspincheck == true
				if (mo.state ~= S_PLAY_ROLL)
					p.pflags = $ & ~(PF_SPINNING)--|PF_SPINDOWN)
				end
				mo.nickspincheck = false
			end
		end
		if not NickSlide(mo) and p.nick_vfx and p.nick_vfx.valid and p.nick_vfx.type == MT_WOOSHSLD_FOLLOW
			if not (p.playerstate != PST_LIVE)
			or p.speed < 40*mo.scale
				P_RemoveMobj(p.nick_vfx)
			end
		end
		if not (mo.nickspincheck)
			mo.nickspincheck = false
		end
		--Disable ability from Saxa's Murder Mystery
		if gametype != (GT_SAXAMM or GT_ZE2)
			if not mo.dash_used
				mo.dash_used = false
			end
			if not (mo.doublejumpnickdrawangle)
				mo.doublejumpnickdrawangle = 0
			end
			if mo.state == S_PLAY_NICKDOUBLEJUMP
				mo.doublejumpnickdrawangle = $ + FixedAngle(40*FRACUNIT)
				p.drawangle = mo.doublejumpnickdrawangle
			else
				mo.doublejumpnickdrawangle = 0
			end
			if not (mo.nickdash)
				mo.nickdash = 0
			end
			if mo.nickdash > 0
				mo.nickdash = $ - 1
			end
			if NickDamage(mo)
				p.panim = PA_DASH
				if not NickDash(mo)
					nk.GhostShape(mo, mo.color)
					if (nk.IsPlayerOnGround(mo)) or (mo.eflags & MFE_JUSTHITFLOOR)
						mo.state = S_PLAY_WALK
					end
				end
			end
			if NickDamage2(mo)
			or NickSlideJump(mo)
			or NickPunchDamage(mo)
				p.powers[pw_strong] = $|STR_NICK2
			end
			if not (p.mo.nickdash_cooldown)
				p.mo.nickdash_cooldown = 0
			end
			if p.mo.nickdash_cooldown > 0
				p.mo.nickdash_cooldown = $ - 1
			end
			if p.mo.nickdash_cooldown > 0
				p.mo.dash_used = true
			end
			if NickDash(p.mo)
				p.panim = PA_DASH
    			if (mo.eflags & MFE_JUSTHITFLOOR)
					mo.momx = $/2
					mo.momy = $/2
					P_SpawnSkidDust(p, 13*FRACUNIT, sfx_s3k7e)
					mo.nickdash_cooldown = 3
					mo.state = S_PLAY_WALK
				end
			end
			if (nk.IsPlayerOnGround(mo)) or (mo.eflags & MFE_JUSTHITFLOOR)
			and mo.dash_used
			and not (cmd.buttons & BT_SPIN)
				mo.dash_used = false
			end
		end
		
		/*if not (cmd.buttons & BT_JUMP)
			p.jumphold = false
		else
			p.jumphold = true
		end*/
		if mo.nick_homingcheck
			mo.momz = 8*FU
			if cmd.forwardmove
			or cmd.sidemove
				if not p.powers[pw_sneakers]
					mo.momx = $/2
					mo.momy = $/2
				end
			else
				mo.momx = 0
				mo.momy = 0
			end
			p.homingtimer = 0
			p.chaintimer = 1*TICRATE
			if p.chaintimer
				mo.state = S_NICKKICK_OFFHOMING
			end
			if (consoleplayer == p)
				P_StartQuake(8*mo.scale, TICRATE/5, {mo.x, mo.y, mo.z})
			end
			S_StartSound(mo, sfx_bedeen)
			mo.nick_homingcheck = false
		end
		if NickDamage(mo)
			if mo.nick_touchcheck == true
				p.homingtimer = 0
			end
		elseif mo.nick_touchcheck == true
			mo.nick_touchcheck = false
		end
		
		--Custom wait animations activation
		if mo.state == S_PLAY_WAIT
			mo.state = S_NICK_WAIT01
		end
		
		if mo.state >= S_NICK_WAIT01 and mo.state <= S_NICK_WAIT10
			if cmd.forwardmove or cmd.sidemove
				mo.state = S_PLAY_WALK
			end
		end
		--Custom 2 - Shield Ability
		//Bro wtf...Why is code is big...I said why...PF_SHIELDABILITY IS WEIRD WORKS!!!!!
		if p.powers[pw_carry] == CR_NONE
			--spawn attraction target
			if (p.powers[pw_shield] & SH_NOSTACK == SH_ATTRACT)
				local t = P_LookForEnemies(p,false,false)
				
				if t and t.valid
				and not (mo.state >= 59 and mo.state <= 64)
					P_SpawnLockOn(p, t, S_LOCKON2)
				end
			end
		end
		
		if not (p.mo.nickshieldwork)
			p.mo.nickshieldwork = false
		end
		if not (p.mo.nick2button)
			p.mo.nick2button = false
		elseif not (cmd.buttons & BT_CUSTOM2)
			p.mo.nick2button = false
		elseif (nk.IsPlayerOnGround(mo))
			p.mo.nick2button = true
		end
		if (nk.IsPlayerOnGround(mo))
			p.charflags = $|SF_NOSHIELDABILITY
			p.mo.nickshieldwork = false
		else
			if p.mo.nick2button == true
				p.mo.nickshieldwork = true
			end
		end
		if (cmd.buttons & BT_CUSTOM2)
		and not p.exiting
		and not p.powers[pw_carry]
		and not (p.pflags & PF_STASIS)
		and not (p.mo.tracer and p.mo.tracer.type == MT_TUBEWAYPOINT) --It's 2.1 Check how by the way worked good in 2.2
		and not srb2p -- check about Srb2 Persona
		and not (nk.IsPlayerOnGround(p.mo)) --check if are you air
		and not (CBW_Battle or G_RingSlingerGametype()) --Check about Battle mod and Ring Slinger Gametypes. Like Mach and e.t.c
		and (p.pflags & PF_JUMPED)
		and not (p.pflags & PF_SHIELDABILITY)
		and not p.mo.nick2button
			local checkshields = SH_NOSTACK
			if (p.powers[pw_shield] & checkshields == SH_ARMAGEDDON)
				A_OldRingExplode(p.mo, MT_SONIC3KBOSSEXPLODE)
				P_BlackOw(p)
				P_StartQuake(20*FRACUNIT, 35, {mo.x, mo.y, mo.z}, p.mo.radius)
				P_Earthquake(p.mo, p.mo, 256*FRACUNIT)
				P_StartQuake(79*FRACUNIT, 3)
				P_FlashPal(p, PAL_WHITE, 3)
				S_StartSound(p.mo, sfx_bkpoof)
				P_NukeEnemies(p.mo, p.mo, RING_DIST)
			elseif (p.powers[pw_shield] & checkshields == SH_WHIRLWIND)
				P_DoJumpShield(p)
				p.pflags = ($|PF_THOKKED)
			elseif (p.powers[pw_shield] & checkshields == SH_ELEMENTAL)
				mo.state = S_PLAY_ROLL
				mo.momx = $ * 3/5
				mo.momy = $ * 3/5
				P_SetObjectMomZ(mo, -25*FRACUNIT)
				S_StartSound(mo,sfx_s3k43)
				p.pflags = ($|PF_THOKKED|PF_SHIELDABILITY)
			elseif (p.powers[pw_shield] & checkshields == SH_ATTRACT)
				local lockonshield = P_LookForEnemies(p, false, false)
				mo.tracer = lockonshield
				mo.target = lockonshield
				if lockonshield and lockonshield.valid
					p.pflags = ($|PF_THOKKED|PF_JUMPED|PF_SHIELDABILITY) & ~(PF_NOJUMPDAMAGE)
					mo.state = S_PLAY_ROLL
					mo.angle = R_PointToAngle2(mo.x, mo.y, lockonshield.x, lockonshield.y)
					S_StartSound(mo, sfx_s3k40)
					p.homing = 1*TICRATE/2
				else
					p.pflags = ($|PF_THOKKED|PF_SHIELDABILITY)
					S_StartSound(mo, sfx_s3ka6)
					p.homing = 2
				end
			elseif (p.powers[pw_shield] & SH_FORCE)
			and not (p.nick_forceused)
				P_InstaThrust(mo, 0, 0*FRACUNIT)
				P_SetObjectMomZ(mo, 0)
				S_StartSound(mo,sfx_ngskid)
				p.pflags = $|PF_THOKKED|PF_SHIELDABILITY
				p.weapondelay = 25
				p.nick_forceused = true
			elseif (p.powers[pw_shield] & checkshields == SH_BUBBLEWRAP)
				mo.momx = $/3
				mo.momy = $/3
				S_StartSound(mo,sfx_s3k44)
				mo.state = S_PLAY_ROLL
				p.pflags = ($|PF_THOKKED|PF_SHIELDABILITY) & ~PF_NOJUMPDAMAGE
				P_SetObjectMomZ(mo, -24*FRACUNIT)
			elseif (p.powers[pw_shield] & checkshields == SH_THUNDERCOIN)
				mo.state = S_PLAY_ROLL
				P_DoJumpShield(p)
				S_StartSound(mo,sfx_s3k45)
				p.pflags = ($|PF_THOKKED|PF_SHIELDABILITY) & ~PF_NOJUMPDAMAGE
			elseif (p.powers[pw_shield] & checkshields == SH_FLAMEAURA)
				mo.state = S_PLAY_ROLL
				P_Thrust(mo, mo.angle, 30*mo.scale)
				S_StartSound(mo,sfx_s3k43)
				p.pflags = ($|PF_THOKKED|PF_SHIELDABILITY) & ~PF_NOJUMPDAMAGE
			end
			p.mo.nick2button = true
			if not p.nick_forceused
				p.pflags = $1|PF_SHIELDABILITY
			end
		end
		--It's all...Yes...Bruh
		--Woosh effect on sprint
		if NickDash(mo)
			Nick.SpawnVFX(p, MT_WOOSH_FOLLOW, mo.scale)
		end
				
		if p.nick_vfx and p.nick_vfx.valid and p.nick_vfx.type == MT_WOOSH_FOLLOW
			if not NickDash(mo)
			or (p.playerstate != PST_LIVE) -- remove it when the p is dead too
				P_RemoveMobj(p.nick_vfx)
			end
			if (p == displayplayer) 
			or (p == secondarydisplayplayer) 
				if not camera.chase
					if p.nick_vfx.valid
					p.nick_vfx.flags2 = $|MF2_DONTDRAW
					end
				else
					if p.nick_vfx and p.nick_vfx.valid
						p.nick_vfx.flags2 = $ & ~MF2_DONTDRAW
					end
				end
			end
		end

		--Take a sit in the cart! don't stand only.
		if p.powers[pw_carry] == CR_MINECART
		and (p.playerstate == PST_LIVE)
			mo.state = S_NICKSIT
		end
		
		--Looking System, only exclusive for STND
		if p.nick_looking
			if mo.state == S_PLAY_STND
			or mo.state == S_PLAY_EDGE
				states[S_PLAY_STND].tics = 6*TICRATE
				states[S_PLAY_EDGE].tics = -1
				if p.aiming >= ANGLE_45/3
					if P_MobjFlip(mo) == 1
						mo.sprite = SPR_NLUP
					else
						mo.sprite = SPR_NLDW
					end
				elseif p.aiming < ANGLE_45/3 and p.aiming > -ANGLE_45/3
					mo.sprite = SPR_PLAY
				elseif p.aiming <= -ANGLE_45/4
					if P_MobjFlip(mo) == 1
						mo.sprite = SPR_NLDW
					else
						mo.sprite = SPR_NLUP
					end
				end
			end
		elseif mo.state == S_PLAY_STND
			if mo.sprite == SPR_NLDW
			or mo.sprite == SPR_NLUP
				states[S_PLAY_STND].tics = 201
				mo.sprite = SPR_PLAY
			end
		end
		
		--Knockback hurt
		if not p.nightstime
			local knkback_activate = FixedMul(p.mo.scale, NICK_KNOCKBACKACTIVATION)
			if P_PlayerInPain(p)
				if (p.speed >= knkback_activate or mo.momz >= knkback_activate)
				and mo.state == (S_PLAY_PAIN)
				and mo.health
				and not p.nick_gotknockback
					S_StartSound(mo, sfx_nickh1)
					if mo.sprite2 == SPR2_PAIN
						mo.sprite = SPR_NKKN
					end
					p.nick_gotknockback = true
				end
			elseif p.nick_gotknockback
				p.nick_gotknockback = false
			end
		
			if mo.state == S_PLAY_PAIN
			and mo.sprite == SPR_NKKN
				mo.spriteroll = $-(ANG15+FixedAngle(FixedDiv(p.speed, p.mo.scale)))
			elseif mo.spriteroll
				mo.spriteroll = 0
			end
		end
		--Slide Jump
		if mo.slidechecktimer > 0
			if mo.spindown and (p.pflags & PF_JUMPED)
			and not mo.nickslidejump
				mo.state = S_NICKSLIDEJUMP1
				mo.nickslidejump = 1
			end
		end
		if mo.nickslidejump == 1 and (p.mo.eflags & MFE_JUSTHITFLOOR)
			mo.nickslidejump = 0
		end
		if mo.state >= S_NICKSLIDEJUMP1 and mo.state <= S_NICKSLIDEJUMP5 and mo.nickslidejump
		and not p.powers[pw_carry]
			if not G_GametypeHasTeams()
				if not p.nick_powerscolor
					nk.GhostShape(mo, SKINCOLOR_PURPLE)
				else
					nk.GhostShape(mo, p.nick_powerscolor)
				end
			else
				nk.GhostShape(mo, mo.color)
			end
		end
		
/*-----------------Emotes!--------------*/
		if not G_RingSlingerGametype()
		if not p.nickemoted
			p.nickemoted = false
		end
		if not p.nick_wonposetrigger
			p.nick_wonposetrigger = false
		end
		if not p.nick_losttrigger
			p.nick_losttrigger = false
		end
		if not p.tflagtwicetimer
			p.tflagtwicetimer = 0
		end
		if not p.tflagcount
			p.tflagcount = 0
		end
		if not p.nick_sitswitch
			p.nick_sitswitch = false
		end
		if Nick.IsPlayerOnGround(mo)
		and p.speed == 0
		and (p.playerstate == PST_LIVE)
			if (cmd.buttons & BT_TOSSFLAG)
				--Goofy aah double tap tossflag check
				if not p.tflagtwicetimer
					if not p.tossflaghold
						p.tflagtwicetimer = TICRATE/2
					end
					if p.tflagcount
						p.tflagcount = 0
					end
				else
					if not p.tossflaghold
						if p.tflagcount == 0
							p.tflagcount = $+1
						elseif p.tflagcount == 1
							p.tflagcount = $+1
						end
					end
				end
				
				--BRUH Emote
				if p.tflagcount == 1
				and p.nickemoted == false
					mo.state = S_NICKBRUH
					p.nickemoted = true
					p.nickemote_spamprotect = 1*TICRATE
					p.tflagcount = 0
				end
				
				p.tossflaghold = true
				
				--Pose 2
				if p.tossflaghold
				and not p.tflagcount
				and (cmd.buttons & BT_FIRENORMAL)
				and p.nickemoted == false
					mo.state = S_NICK_STANCE01
					p.nickemoted = true
					p.nickemote_spamprotect = 1*TICRATE
				end
		
			else
				p.tossflaghold = false
			end
/*-----------------Sit-----------*/
			if (cmd.buttons & BT_FIRENORMAL)
			and not p.exiting
				if not (cmd.buttons & BT_TOSSFLAG)
					if not p.fnormalhold
						if not p.nick_sitswitch
							mo.state = S_NICKSIT2
							p.nick_sitswitch = true
						else
							mo.state = S_PLAY_STND
							p.nick_sitswitch = false
						end
					end
					p.fnormalhold = true
				end
			else
				p.fnormalhold = false
			end
/*-----------------Win (Saxa's MM)-----------*/
			if (MM and MM:isMM())
			
			if MM_N.end_camera
				local sheriff = 
				((MM_N.end_killed and MM_N.end_killed.valid and MM_N.end_killed.p and MM_N.end_killed.p.mm.role == MMROLE_MURDERER)
				and not (MM_N.end_killer and MM_N.end_killer.valid and MM_N.end_killer.health)
				)
				and MM_N.end_killed
				or MM_N.end_killer
				
				if (sheriff and sheriff.valid)
				and p.nick_wonposetrigger == false
				and MM_N.end_camera.swirl_stage == 2
					states[S_NICK_STANCE01].tics = 9
					sheriff.state = S_NICK_STANCE01
					p.nick_wonposetrigger = true
				end
			elseif p.nick_wonposetrigger == true
				p.nick_wonposetrigger = false
				states[S_NICK_STANCE01].tics = 5
			end
			end
			
/*--------------Style Sonic Adventure Support--------------*/
			if p.tallytimer
				if not p.SA_nick_wonposetrigger
					if not p.nickemoted
					and p.tallytimer == 12*TICRATE
						mo.state = S_NICK_STANCE01
						p.nickemoted = true
						p.SA_nick_wonposetrigger = true
						p.nickemote_spamprotect = 1*TICRATE
					end
				end
				if p.tallytimer == 12*TICRATE
					S_StartSound(mo, sfx_nicksl, p)
				end
				states[S_NICK_STANCE01].tics = 60
				states[S_NICK_STANCE09].tics = -1
			elseif p.SA_nick_wonposetrigger
				states[S_NICK_STANCE01].tics = 5
				states[S_NICK_STANCE09].tics = 1*TICRATE
				p.SA_nick_wonposetrigger = false
			end
		end
		end
		
/*--------------Nick killed on end camera (Saxa's MM)--------------*/
		/*if (MM and MM:isMM())
			if MM_N.end_camera
			local killed = MM_N.end_killed
				if (killed and killed.valid)
				and p.nick_losttrigger == false
					S_StartSound(nil, P_RandomRange(sfx_nickh1, sfx_nickh2))
					p.nick_losttrigger = true
				end
			else
				p.nick_losttrigger = false
			end
		end*/
/*---------------Emotes spam protect and button timers--------------*/	
		
		if p.tflagtwicetimer
			p.tflagtwicetimer = $-1
		end
		if p.nickemote_spamprotect
			p.nickemote_spamprotect = $-1
		else
			p.nickemoted = false
		end
			
		if NickPoses(mo)
			if p.speed > 0
				mo.state = S_PLAY_WALK
			end
		end
		if NickPunchDamage(mo)
		and (cmd.buttons & BT_SPIN)
		and not p.canceltimer
			mo.state = S_PLAY_FALL
			S_StartSound(mo, sfx_ngskid)
		end
		if Nick.IsPlayerOnGround(p.mo)
		and gametype != (GT_SAXAMM or GT_ZE2)
			if p.punch_used
			and not (p.cmd.buttons & BT_SPIN)
				p.punch_used = false
			end
		end	
		
/*---------------Nerf uncurl effects--------------*/	
		if gametype != (GT_SAXAMM or GT_ZE2)
			if not p.nick_lockuncurl 
				p.charability = CA_NICKABILITY
			else
				p.charability = CA_NONE
				p.punch_used = true
			end
	
			if p.sprung
				p.nick_lockuncurl = true
			else
				p.nick_lockuncurl = false
			end
		end
	
/*---------------Saxa's Murder Mystery showdown compatibility--------------*/
		if MM and MM.showdownSprites
		and not p.mmshowdown
			MM.showdownSprites[Nick.skin] = "MMSD_NICK"
			p.mmshowdown = true
		end
		
/*---------------Stupid bounce sectors action--------------*/

		if nk.stupidbouncesectors(mo, mo.subsector.sector)
		or (Nick.IsPlayerOnGround(mo) and mo.state == S_NICKPUNCH)
			mo.state = S_PLAY_WALK
			P_MovePlayer(p)
			p.nick_forceused = false
		
			if nk.stupidbouncesectors(mo, mo.subsector.sector)
				mo.state = S_PLAY_ROLL
				p.pflags = $|PF_JUMPED &~(PF_THOKKED|PF_SPINNING)
				p.punch_used = false
			end
		end
		if Nick.IsPlayerOnGround(mo) then
			p.nick_forceused = false
		end
		
			
		--Sprint
		if (cmd.buttons & BT_CUSTOM1)
		and not p.c1down
		and not NICK_RESTRICT_SPRINT
		and Nick.IsPlayerOnGround(p.mo)
		and (cmd.forwardmove or cmd.sidemove)
			if not p.mo.nickslidetime
			if not p.mo.dash_used
				if p.charability2 == CA2_NICKDASH
				and not p.exiting
					if (cmd.forwardmove or cmd.sidemove)
						if p.speed <= NICK_THRUSTCAP*p.mo.scale
							if not p.powers[pw_super]
								if FangsHeist -- not when the player is capped in fang's heist
								and FangsHeist.isMode()
								and FangsHeist.isPlayerNerfed(p)
									P_Thrust(p.mo, p.mo.angle, (NICK_SPRINTMOVE/2)*p.mo.scale)
								else
									P_Thrust(p.mo, p.mo.angle, NICK_SPRINTMOVE*p.mo.scale)
								end
							else
								P_Thrust(p.mo, p.mo.angle, (NICK_SPRINTMOVE*2)*p.mo.scale)
							end
						else
							P_Thrust(p.mo, p.mo.angle, p.mo.scale)
						end
					end
					if (p.mo.eflags & MFE_UNDERWATER)
						P_SetObjectMomZ(p.mo, 5*FU/2)
					else
						P_SetObjectMomZ(p.mo, 5*FRACUNIT)
					end
					p.mo.eflags = $ & ~MFE_JUSTHITFLOOR --see, this is the trick
					p.mo.state = S_NICKSPRINT
					p.mo.nickdash = 3
					P_SpawnGhostMobj(p.mo)
					S_StartSound(p.mo, sfx_nckspr)
					p.pflags = $ |PF_THOKKED
					p.mo.dash_used = true
				end
			end
			end
		end
		if mo.state == S_NICKSPRINT
			p.drawangle = p.mo.angle
		end
		if (cmd.buttons & BT_CUSTOM1)
			p.c1down = true
		else
			p.c1down = false
		end
-- Fall/Rising animations (Reusable) by: Balls
		if not (p.pflags & PF_JUMPED or p.pflags & PF_THOKKED or p.pflags & PF_STASIS 
		or p.pflags & PF_JUMPSTASIS or mo.state == S_PLAY_WAIT or NickPoses(mo)
		or mo.state == S_NICKSPRINT)
			if (p.panim == PA_IDLE or p.panim == PA_WALK or p.panim == PA_RUN or p.panim == PA_DASH)
			and not nk.IsPlayerOnGround(mo)
			and mo.momz < 1
			and not p.powers[pw_carry]
				mo.state = S_PLAY_FALL
			end
			if (p.panim == PA_IDLE or p.panim == PA_WALK or p.panim == PA_RUN or p.panim == PA_DASH)
			and not nk.IsPlayerOnGround(mo)
			and mo.momz > 0
			and not p.powers[pw_carry]
				mo.state = S_PLAY_SPRING
			end
		end
		
		
		--power up the player when using wolf buster at medium speeds
		if NickPunchDamage(mo)
			if speed >= Nick.WB_medium_speed*mo.scale
				p.powers[pw_strong] = $|STR_NICK
			else
				p.powers[pw_strong] = $ &~STR_NICK
			end
		end
			
		
		--Fix equinox doing weird stuff
		if p.spintapping
		or p.spintapready
			p.spintapready = false
			p.spintapping = false
		end
	end
		
/* Fixing the custom states animation still
   displayed when changing characters */
	if p.mo.skin != Nick.skin
		if (p.mo.state >= S_NICK_WAIT01 and p.mo.state <= S_NICK_WAIT10)
			p.mo.state = S_PLAY_STND
		end
		if p.mo.translation
			p.mo.translation = nil
		end
	end
end)

addHook("AbilitySpecial", CustomDoubleJump) --Hooked Double Jump

addHook("PlayerHeight", function(p)
	if NickSlideJump(p.mo)
		return P_GetPlayerSpinHeight(p)
	end
end)

addHook("PlayerCanEnterSpinGaps", function(p)
	if NickSlideJump(p.mo)
	or NickSlide(p.mo)
		return true
	end
end)

/*---------------------SPIN BUTTON ABILITIES----------------------*/
addHook("SpinSpecial", function(p)
	if p.mo and p.mo.skin == Nick.skin
	and gametype != (GT_SAXAMM or GT_ZE2)
		local cmd = p.cmd
		if not Nick.IsPlayerOnGround(p.mo)
		--Wolf Buster
			if (p.pflags & PF_JUMPED)
				if p.spindown return end
				if not p.punch_used
				and not p.nick_lockuncurl
				and not p.sprung
				and not p.gotflag
				and not NICK_RESTRICT_WOLFBUSTER
					if FangsHeist -- not when the player is capped in fang's heist
					and FangsHeist.isMode()
					and FangsHeist.isPlayerNerfed(p) return end
					p.mo.state = S_NICKPUNCH
					p.mo.momz = 0
					--Better caps to Wolf Buster, thanks Luigi Budd
					local thrust = p.speed + (NICK_WOLFBUSTERMOVE*p.mo.scale)
                    if thrust > NICK_THRUSTCAP*p.mo.scale
                        if (p.speed < NICK_THRUSTCAP*p.mo.scale)
                            thrust = (NICK_THRUSTCAP*p.mo.scale - p.speed) + p.speed
                        else
                            thrust = 0
                        end
                    end
                    if thrust > 0
                        P_InstaThrust(p.mo, p.mo.angle, thrust)
                    else
                        P_InstaThrust(p.mo, p.mo.angle,
                            R_PointToDist2(0,0, p.mo.momx,p.mo.momy)
                        )
                    end
					S_StartSound(p.mo, sfx_spratk)
					p.pflags = $ |PF_JUMPED|PF_THOKKED
					p.punch_used = true
					p.kickdid = true
					p.dash_used = true
					p.cannot_nickusekick = true
					p.canceltimer = 1
				else return end
			end
		end
	end
end)